// Telegrammer - Telegram Bot Swift SDK.
// This file is autogenerated by API/generate_wrappers.rb script.

/**
 You can provide an animation for your game so that it looks stylish in chats (check out Lumberjack for an example). This object represents an animation file to be displayed in the message containing a game.

 SeeAlso Telegram Bot API Reference:
 [Animation](https://core.telegram.org/bots/api#animation)
 */
public final class Animation: Codable {

    /// Custom keys for coding/decoding `Animation` struct
    enum CodingKeys: String, CodingKey {
        case fileId = "file_id"
        case thumb = "thumb"
        case fileName = "file_name"
        case mimeType = "mime_type"
        case fileSize = "file_size"
    }

    /// Unique file identifier
    public var fileId: String

    /// Optional. Animation thumbnail as defined by sender
    public var thumb: PhotoSize?

    /// Optional. Original animation filename as defined by sender
    public var fileName: String?

    /// Optional. MIME type of the file as defined by sender
    public var mimeType: String?

    /// Optional. File size
    public var fileSize: Int?


    public init (fileId: String, thumb: PhotoSize? = nil, fileName: String? = nil, mimeType: String? = nil, fileSize: Int? = nil) {
        self.fileId = fileId
        self.thumb = thumb
        self.fileName = fileName
        self.mimeType = mimeType
        self.fileSize = fileSize
    }
}
